﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SL_AR_SilentParametricReport
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();         
        }

        /// <summary>
        /// Selection Changed Event triggers the redirection to the 
        /// query WebForm page with the parameters using query string
        /// </summary>        
        private void cityCombo_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            var currenthost = string.Format("http://{0}:{1}/",
                               Application.Current.Host.Source.DnsSafeHost,
                               Application.Current.Host.Source.Port);

            Uri codeuri = new Uri(currenthost + "ReportParameter.aspx?ReportType=Section&ParamData=" + ((ContentControl)(cityCombo.SelectedValue)).Content.ToString());
            WebClient codereport = new WebClient();
            codereport.OpenReadCompleted += new OpenReadCompletedEventHandler(client_OpenReadCompleted);
            codereport.OpenReadAsync(codeuri);
        }

        private void client_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            if (e.Result != null)
            {
                Stream rdf = (Stream)e.Result;
                LoadReportFromStream(rdf);
            }
        }

        private void LoadReportFromStream(Stream stream)
        {
            //Loads the RDF stream and displays in the Silverlight Viewer
            GrapeCity.Viewer.Common.StreamDocumentLoader rdfdocument = new GrapeCity.Viewer.Common.StreamDocumentLoader(stream, GrapeCity.Viewer.Common.DocumentFormat.Rdf);
            SLViewer.LoadDocument(rdfdocument);
        }

    }
}
